**Please do not manually create issues on GitHub.**

### Creating an Issue

If you have a question on how something works, or its expected functionality, you might want to visit the [Ionic Forum](http://forum.ionicframework.com/) first.

If you think you have found a bug, or have a new feature idea, please start by making sure it hasn't already been [reported](https://github.com/driftyco/ionic/issues?state=open). You can search through existing issues to see if someone's reported one similar to yours.

Next, [create a new issue](http://ionicframework.com/submit-issue/) that briefly explains the problem, and provides a bit of background as to the circumstances that triggered it.

### Issue Etiquette Guidelines

Poor  attitude, ranting, name-calling, bullying, being a jerk, complaining, or spamming are fruitless and unacceptable. Issues that violate the open source spirit of this community, or  any of the guidelines listed here, may result in your Issue being deleted or reposted to our Forum, a better place for debate and discussion. If you wish to contribute, either make your response respectful or do not bother to respond. You’ll find it’s pretty ineffective.

Simply put: be respectful and act like an adult. Critiques are better made on the Forum. If you can’t do that, this isn’t a community  for you.


### Pull Request Guidelines

Please use [Commitizen](https://github.com/commitizen/cz-cli#installing-the-command-line-tool) to commit to this repository. This ensures your commits will match our git conventions. It can be installed by running the following command (add sudo if on OSX/Linux):

```
npm install -g commitizen
```

Then, when you want to commit, instead of writing `git commit` you will write:

```
git cz
```

This will prompt you with some questions.

When in doubt, keep your pull requests small. To give a PR the best chance of getting accepted, do not bundle more than one "feature" or bug fix per PR. Doing so makes it very hard to accept it if one of the fixes has issues.

It's always best to create two smaller PRs than one big one.

### Style

Always use two spaces, no tabs. This goes for any HTML, CSS, or Javascript.

### License

By contributing your code to the driftyco/ionic GitHub Repository, you agree to license your contribution under the MIT license.
